<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 05/29/2004 *
 * ===============                              Last change: 11/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : autopurge.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Automatical purging of outdated mail links       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auto-Loeschung von veralteten Mail-Links         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Abort if autopurge is not active or disabled by admin
if ((!isExtensionActive('autopurge')) || (getConfig('auto_purge_active') != 'Y') || (getConfig('ap_del_mails') != 'Y')) {
	// Abort here
	return false;
} // END - if

// Okay, let's check for deleted mails
$result_mails = SQL_QUERY("SELECT
	`sender`
FROM
	`{?_MYSQL_PREFIX?}_pool`
WHERE
	`data_type`='DELETED' AND `timestamp` <= (UNIX_TIMESTAMP() - {?ap_dm_timeout?})
ORDER BY
	`sender` ASC", __FILE__, __LINE__);

// Reset counter...
$DELETED = 0;

// Do we have "purged" mails?
if (SQL_NUMROWS($result_mails) > 0) {
	// Okay, check for their sender's
	while ($content = SQL_FETCHARRAY($result_mails)) {
		// Check now...
		$fount = SQL_NUMROWS(SQL_QUERY_ESC("SELECT userid FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
			array(bigintval($content['sender'])), __FILE__, __LINE__));
		if ($found == 0) {
			// Okay we found some mails!
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_pool` WHERE `sender`=%s",
				array(bigintval($content['sender'])), __FILE__, __LINE__);
			$DELETED += SQL_AFFECTEDROWS();

			// Reset query (to prevent possible errors) ...;
			$result_mails = SQL_QUERY("SELECT
	`sender`
FROM
	`{?_MYSQL_PREFIX?}_pool`
WHERE
	`data_type`='DELETED' AND timestamp <= (UNIX_TIMESTAMP() - {?ap_dm_timeout?})
ORDER BY
	`sender` ASC", __FILE__, __LINE__);
		}
	}
}

// Free memory
SQL_FREERESULT($result_mails);

// Now let's check for stats entries as well;
$result_mails = SQL_QUERY("SELECT
	`userid` AS sender
FROM
	`{?_MYSQL_PREFIX?}_user_stats`
WHERE
	`timestamp_send` <= (UNIX_TIMESTAMP() - {?ap_dm_timeout?})
ORDER BY
	`sender` ASC", __FILE__, __LINE__);

// Do we have "purged" mails?
if (SQL_NUMROWS($result_mails) > 0) {
	// Okay, check for their sender's
	while ($content = SQL_FETCHARRAY($result_mails)) {
		// Check now...
		$found = SQL_NUMROWS(SQL_QUERY_ESC("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
			array(bigintval($content['sender'])), __FILE__, __LINE__));
		if ($found == 0) {
			// Okay we found some mails!
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `sender`=%s",
				array(bigintval($content['sender'])), __FILE__, __LINE__);
			$DELETED += SQL_AFFECTEDROWS();

			// Reset query (to prevent possible errors) ...
			$result_mails = SQL_QUERY("SELECT
	`userid` AS sender
FROM
	`{?_MYSQL_PREFIX?}_user_stats`
WHERE
	`timestamp_send` <= (UNIX_TIMESTAMP() - {?ap_dm_timeout?})
ORDER BY
	`sender` ASC", __FILE__, __LINE__);
		}
	}
}

// Free memory
SQL_FREERESULT($result_mails);

// Do we have deleted mails and the admin want's to receive a notification
if (($DELETED > 0) && (getConfig('ap_dm_notify') == 'Y')) {
	// Send out email to admin
	sendAdminNotification(getMessage('AUTOPURGE_ADMIN_DEL_MAILS_SUBJECT'), 'admin_autopurge_del_mails', $DELETED, '');
} // END - if

//
?>
