<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/26/2008 *
 * ================                             Last change: 11/26/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-booking.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : User bookings                                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Kontoauszug der Mitglieder                       *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Version number
setThisExtensionVersion('0.0');

// Version history array (add more with , '0.1.0' and so on)
setExtensionVersionHistory(array('0.0'));

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running (modules.php?module=admin is called)
		// Configuration entries
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `booking_per_page` TINYINT(3) UNSIGNED NOT NULL DEFAULT 10");
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `booking_purge` BIGINT(20) UNSIGNED NOT NULL DEFAULT ".(getConfig('ONE_DAY') * 3)."");

		// Drop/create table for user bookings
		addExtensionSql("DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_user_book`");
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_user_book`(
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`subject` VARCHAR(255) NOT NULL DEFAULT 'missing',
`mode` ENUM('add','sub') NOT NULL DEFAULT 'add',
`points` FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.0000,
INDEX (`userid`),
PRIMARY KEY (`id`)
) TYPE={?_TABLE_TYPE?} COMMENT='Member points booking table'");

		// Admin menu
		addAdminMenuSql('setup','config_booking','Kontoauszug','Einstellungen am Kontoauszug f&uuml;r Mitglieder vornehmen.', 14);
		addAdminMenuSql('user','list_booking','Kontoauszug','Kontoausz&uuml;ge aller Ihrer Mitglieder oder eines einzelnen Mitgliedes anzeigen.',10);

		// Member menu
		addMemberMenuSql('main','booking','{OPEN_CONFIG}POINTS{CLOSE_CONFIG}-Kontoauszug','N','Y',5);

		// Add the filters
		registerFilter('add_points', 'ADD_BOOKING_RECORD', false, true, getExtensionDryRun());
		registerFilter('sub_points', 'ADD_BOOKING_RECORD', false, true, getExtensionDryRun());
		break;

	case 'remove': // Do stuff when removing extension
		addExtensionSql("DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_user_book`");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `what` IN ('config_booking','list_booking')");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='booking'");

		// Remove the filters
		unregisterFilter('add_points', 'ADD_BOOKING_RECORD', false, true, getExtensionDryRun());
		unregisterFilter('sub_points', 'ADD_BOOKING_RECORD', false, true, getExtensionDryRun());
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y', `locked`='N' WHERE `what`='booking' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='N', `locked`='Y' WHERE `what`='booking' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql('');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes('');
				break;
		}

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown extension mode %s detected.", getExtensionMode()));
		break;
}

// [EOF]
?>
